﻿using Hotline.Users;
using XF.Domain.Dependency;
using XF.Domain.Repository;

namespace Hotline.Article
{
    public class CircularRecordDomainService : ICircularRecordDomainService, IScopeDependency
    {
        private readonly IRepository<CircularRecord> _circularRecordRepository;
        public CircularRecordDomainService(IRepository<CircularRecord> circularRecordRepository)
        {
              _circularRecordRepository = circularRecordRepository;
        }
        public async Task RecordUserHandle(string userId, bool isAdd, CancellationToken cancellationToken)
        {
            var userRecord = await _circularRecordRepository.GetAsync(x => x.UserId == userId);
            if (isAdd)
            {
                if (userRecord!=null)
                {
                    if (userRecord.RecordCount>0)
                    {
                        userRecord.RecordCount++;
                    }
                    await _circularRecordRepository.UpdateAsync(userRecord);
                }
                else
                {
                    userRecord = new CircularRecord();
                    userRecord.UserId = userId;
                    userRecord.CircularType = Share.Enums.Article.ECircularType.Person;
                    userRecord.RecordCount = 1;
                    await _circularRecordRepository.AddAsync(userRecord);
                }
            }
            else
            {
                if (userRecord!=null)
                {
                    if (userRecord.RecordCount > 0)
                    {
                        userRecord.RecordCount--;
                    }
                    else
                    {
                        userRecord.RecordCount = 0;
                    }
                }
            }
        }

        public async Task RecordOrgHandle(string orgId, bool isAdd, CancellationToken cancellationToken)
        {
            var orgRecord = await _circularRecordRepository.GetAsync(x => x.OrgId == orgId);
            if (isAdd)
            {
                if (orgRecord!=null)
                {
                    if (orgRecord.RecordCount > 0)
                    {
                        orgRecord.RecordCount++;
                    }
                    await _circularRecordRepository.UpdateAsync(orgRecord);
                }
                else
                {
                    orgRecord = new CircularRecord();
                    orgRecord.OrgId = orgId;
                    orgRecord.CircularType = Share.Enums.Article.ECircularType.Person;
                    orgRecord.RecordCount = 1;
                    await _circularRecordRepository.AddAsync(orgRecord);
                }
            }
            else
            {
                if (orgRecord != null)
                {
                    if (orgRecord.RecordCount > 0)
                    {
                        orgRecord.RecordCount--;
                    }
                    else
                    {
                        orgRecord.RecordCount = 0;
                    }
                }
            }
        }
    }
}
